<?php
 
class Cookie
{
    
    private static $_reserved = array();
    
    private function __construct() {}
   
   
   
   
    
    public static function del($key)
    {
        self::delete($key);
    }
   
   
   
   
    
    public static function delete($key)
    {
        
        $key = self::_scrubKey($key);
       
        if (self::exists($key)) {                        
            if (is_array($key)) {                        
                list ($k, $v) = each($key);              
                $key = $k . '[' . $v . ']';              
                setcookie($key, false, time() - 3600);   
                unset($_COOKIE[$k][$v]);                 
            } else if (is_array($_COOKIE[$key]) ) {      
                foreach ($_COOKIE[$key] as $k => $v)
                {
                    
                    $cookie = $key . '[' . $k . ']';
                   
                    
                    setcookie($cookie, false, time() - 3600);
                   
                    
                    unset($_COOKIE[$key][$k]);
                }
            }
           
            
            else
            {
                
                setcookie($key, false, time() - 3600);
               
                
                unset($_COOKIE[$key]);
            }
        }
    }
   
    
    public static function exists($key)
    {
        
        $key = self::_scrubKey($key);
       
        
        if (is_array($key))
        {
            
            list ($k, $v) = each($key);
           
            
            if (isset($_COOKIE[$k][$v])) return true;
        }
       
        
        else if (isset($_COOKIE[$key])) return true;
       
        
        return false;
    }
   
   
   
   
   
    public static function get($key)
    {
        
        $key = self::_scrubKey($key);
       
        
        if (is_array($key))
        {
            
            list ($k, $v) = each($key);
           
            
            if (isset($_COOKIE[$k][$v])) return $_COOKIE[$k][$v];
        }
        
        else if (isset($_COOKIE[$key])) return $_COOKIE[$key];
           
        
        else return null;
    }
   
    
    public static function contents()
    {
        return $_COOKIE;
    }
   
    
    public static function set(
        $key,
        $value,
        $expire = 0,            
        $path = '',             
        $domain = '',           
        $secure = false,        
        $httponly = true        
    ){       
        
        if (!in_array($key, self::$_reserved))
        {       
            
            $key = self::_scrubKey($key, true);
               
            
            setcookie($key, $value, $expire, $path, $domain, $secure, $httponly);   
        }
           
        
        else Error::warning('Could not set key -- it is reserved.', __CLASS__);
    }
   
    
    private static function _scrubKey($key, $toString = false)
    {
        
        if ($toString)
        {
            
            if (is_array($key))
            {
                
                list ($k, $v) = each($key);
               
                
                $key = $k . '[' . $v . ']';
            }
        }
       
        
        else if (!is_array($key))
        {
            
            if (preg_match('/([\w\d]+)\[([\w\d]+)\]$/i', $key, $matches))
            {
                
                $key = array($matches[1] => $matches[2]);
            }
        }
       
        
        return $key;
    }
}
?>
