<?php
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/GedComException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/gedcom/GedComLine.php" );
    
class GedComReader 
{
    
   
   private $gGedComFileName;
   
   private $gLineNumber = 0;
   
   private $gFileHandle;
   
   private $gRawLine = "";
   
   
   
    
   public function __construct( $inGedComFileName )
   {
       $this->gGedComFileName = $inGedComFileName;
      if ( !file_exists( $this->gGedComFileName ) || !is_readable( $this->gGedComFileName ) ) {
         throw new GedComException( "File '$this->gGedComFileName' does not exist/cannot be read", PalooseException::SITEMAP_GENERATOR_RUN_ERROR );
      }
      
      ini_set( 'auto_detect_line_endings', true );
      $this->gFileHandle = @fopen( $this->gGedComFileName, "r" );
   }
   
   
   
   public function getNextLine()
   {
      try {
         if ( !feof( $this->gFileHandle ) ) {
            $this->gLineNumber++;
            $this->gRawLine = fgets( $this->gFileHandle, 4096 );
            try {
               return new GedcomLine( $this->gRawLine, $this->gLineNumber );
            } catch ( GedComException $e ) {
                 throw new GedComException( $e->getMessage(), $e->getCode() );
            }
         } else {
            fclose( $this->gFileHandle );
            return null;
         }
      } catch ( GedComException $e ) {
        throw new GedComException( $e->getMessage(), $e->getCode() );
      }
   }
   
   
   
   public function getRawLine()
   {
      return $this->gRawLine;
   }
   
   
  
   public function getLineNumber()
   {
      return $this->gLineNumber;
   }
}
?>
