<?php
require_once( PALOOSE_LIB_DIRECTORY . "/authentication/AuthenticationManager.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/InternalException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/UserException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/RunException.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/exception-handling/ExitException.php" );
 
class ComponentConfigurations {
   private $gDefault;
   
   
   private $gComponentList;
      
   
   
   public function __construct()
   {
      $this->gComponentList = array();
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $pipelinesDom = new DOMDocument;
      $pipelinesDom->appendChild( $pipelinesDom->importNode( $inNode, 1 ) );
      $xPath = new domxpath( $pipelinesDom );
      $xPath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $nodeList = $xPath->query( "//*" );
      $idx = 0;
      foreach ( $nodeList as $node ) {
         if ( $node->localName == "authentication-manager" ) {
            try {
               $manager = new AuthenticationManager( $node );
               $manager->parse( $node );
               $this->gComponentList[ "authentication-manager" ] = $manager;
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         } else if ( $node->localName == "global-variables" ) {
             $globalsNodeList = $xPath->query( "*/*" );
             foreach ( $globalsNodeList as $globalNode ) {
                $globalsModule = Environment::$modules[ 'global' ];
                if ( $globalsModule == null ) echo "!!!!";
                $globalsModule->add( $globalNode->tagName, $globalNode->textContent );
            }
         }
      }
   }
   
   
   
   public function getComponentList()
   {
      return $this->gComponentList;
   } 
   
   
   
   public function getComponent( $inName )
   {
       if ( isset( $this->gComponentList[ $inName ] ) ) {
          return $this->gComponentList[ $inName ];
       } else {
          throw new UserException( "Component $inName does not exist", 0, NULL );  
       }
   } 
   
   
   
   public function toString()
   {
      $mess = " <component-configurations>\n";
      foreach ( $this->gComponentList as $node ) {
         $mess .= $node->toString();
      }
      $mess .= " </component-configurations>\n";
      return $mess;
   }
}
?>
