<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Browser.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElement.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/pipelines/PipeElementInterface.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/Selector.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/selection/SelectorPipeElement.php" );
class RequestParameterSelector extends SelectorPipeElement implements PipeElementInterface
{
    
   
   
   
    
   public function __construct( DOMDocument $inDOM, $inType = "", $inSrc = "", $inComponent = NULL )
   {
      parent::__construct( $inDOM, $inType, $inSrc, $inComponent );
   }
   
   
   
   public function run( VariableStack $inVariableStack, $inURL, $inQueryString, DOMDocument $inDOM )
   {
      
      $requestParameterModule = Environment::$modules[ 'request-param' ];
      $params = $requestParameterModule->getParams();
      foreach ( $params as $name => $value ) {
         $this->gParameters->setParameter( $name, $value );
      }
      $testName = $this->gParameters->getParameter( 'parameter-name' );
        if ( $testName == NULL ) {
            $testName = $this->gComponent->getDefaultParameter();
        }
        $testValue = $this->gParameters->getParameter( $testName );
      
      $testFound = ( $testValue != NULL and $this->gWhenPipes[ $testValue ] != NULL );
      if ( $testFound === true ) {
         $pipe = $this->gWhenPipes[ $testValue ];
         $documentDOM = $pipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      } else {
         $pipe = $this->gOtherwisePipe;
         $documentDOM = $pipe->run( Environment::$variableStack, $inURL, $inQueryString, $inDOM );
      }
      return $documentDOM;
   }
}
 
class _RequestParameterSelector extends Selector {
    
   
   
   private $gDefaultParameter;
   
   
   
   
   public function __construct( $inName, $inSrc, DOMNode $inParameterNode, $inIsCachable )
   {
      parent::__construct( $inName, $inSrc, $inParameterNode, $inIsCachable );
      $this->gPackageName = "RequestParameterSelector";
      
        
      $requestParameterDOM = new DOMDocument;
      $requestParameterDOM->appendChild( $requestParameterDOM->importNode( $inParameterNode, 1 ) );
        
      $xpath = new domxpath( $requestParameterDOM );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $component = $xpath->query( "//m:selector/*" );
      
      $this->gDefaultParameter = Utilities::getXPathListStringItem( 0, $xpath, "//m:selector/m:parameter-name" );
  }
   
   
   
    
   public function isValid()
   {
      $parentIsValid = parent::isValid();
      
      return $parentIsValid;
   } 
   
   
   
    
   public function getDefaultParameter()
   {
      return $this->gDefaultParameter;
   } 
   
   
   
    
   public function toString()
   {
      if ( $this->gParameters == NULL && $this->gBrowserAgent == NULL ) {
         return "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'/>\n";
      }
      $mess = "   <selector name='{$this->gType}' src='{$this->gSrc}' package='{$this->gPackageName}'>\n";
      if ( $this->gParameters != NULL ) {
         while ( list( $name, $value ) = each( $this->gParameters ) ) {
            $mess .= "    <parameter name='$name' value='$value'/>\n";
         }
         reset( $this->gParameters );
      }
      if ( $this->gDefaultParameter != NULL ) {
         $mess .= "    <parameter-name>" . $this->gDefaultParameter . "</parameter-name>\n";
      }
      $mess .= "   </selector>\n";
      return $mess;
   }
}
?>
