<?php
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Utilities.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/environment/Environment.php" );
require_once( PALOOSE_LIB_DIRECTORY . "/viewing/View.php" );
class Views {
   
   private $gViews;
      
   
   
   
   public function __construct()
   {
      $this->gViews = array();
   }
   
   
   
   public function parse( DOMNode $inNode )
   {
      
      $viewsDom = new DOMDocument;
      $viewsDom->appendChild( $viewsDom->importNode( $inNode, 1 ) );
      
      $xpath = new domxpath( $viewsDom );
      $xpath->registerNamespace( "m", Environment::$configuration[ 'sitemapNamespace' ] );
      $view = $xpath->query( "//m:views/*" );
      
      foreach ( $view as $node ) { 
         $name = $node->getAttribute( "name" );
         $fromLabel = $node->getAttribute( "from-label" );
         $fromPosition = $node->getAttribute( "from-position" );
         
         if ( $this->gViews != NULL and array_key_exists( $name, $this->gViews ) ) {
            $viewDom = new DOMDocument;
            $viewDom->appendChild( $viewDom->importNode( $node, 1 ) );
            throw new UserException( "Duplicate view name '" . $name . "' found", PalooseException::SITEMAP_VIEW_PARSE_ERROR, $viewDom );
         } else {
            try {
               $view = new View( $name, $fromLabel, $fromPosition, $node );
               $view->parse( $node );
               $this->gViews[ $name ] = $view;
            } catch ( UserException $e ) {
               throw new UserException( $e->getMessage(), $e->getCode(), $e->getDOMScrap() );
            }
         }
      }
   }
   
   
   
    
   public function getView( $inName )
   {
      if ( array_key_exists( $inName, $this->gViews ) ) {
         return $this->gViews[ $inName ];
      }
      return NULL;
   }
   
   
   
    
   public function toString()
   {
      $mess = "";
      if ( $this->gViews != null ) {
         $mess = "  <views>\n";
         foreach ( $this->gViews as $name => $view ) {
            $mess .= $view->toString();
         }
         $mess .= "  </views>\n";
      }
      return $mess;
   }
}
?>
